dnl======================================================================
dnl GDS_CHECK_FFTW3
dnl   Check if FFTW3 is installed
dnl======================================================================

AC_DEFUN([AC_GDS_CHECK_FFTW3],
[
have_fftw3f="no"
have_fftw3d="no"
fftwcflags=
fftwlibs=
ext_fftw="no"
PKG_CHECK_MODULES([FFTWF], [fftw3f >= 3.2.1], have_fftw3f="yes", have_fftw3f="no")
PKG_CHECK_MODULES([FFTWD], [fftw3  >= 3.2.1], have_fftw3d="yes", have_fftw3d="no")
if test "$have_fftw3f" = "yes"; then
  fftwcflags="$FFTWF_CFLAGS -DFFTW3"
  fftwlibs="$FFTWF_LIBS"
  if test "$have_fftw3d" = "yes"; then
    fftwcflags="$fftwcflags -DFFT_DOUBLE"
    fftwlibs="$fftwlibs -lfftw3"
  fi
else
  AC_CHECK_LIB(fftw3f, fftwf_execute_dft, have_fftw3f="yes", have_fftw3f="no")
  AC_CHECK_LIB(fftw3,  fftw_execute_dft,  have_fftw3d="yes", have_fftw3d="no")
  if test "$have_fftw3f" = "yes"; then
    pkgf=/usr
    pkgl=$pkgf/lib
    for d in `echo "$LD_LIBRARY_PATH" | sed -e "s/:/ AC_ARG_ENABLE(dtt,
	      AS_HELP_STRING([--enable-dtt],[Build dtt]),
	      [need_dtt=${enableval}]
)
/g"` ; do
      if test -f "$d/libfftw3f.so" -o -f "$d/libfftw3f.a" ; then
      	pkgl=`echo $d | sed -e 's,/$,,g'`
      	pkgf=`echo $pkgl | sed -e 's,/lib.*$,,'`
      	echo $pkgf
      	break
      fi
    done
    fftwcflags="-I$pkgf/include -DFFTW3"
    fftwlibs="-L$pkgl -lfftw3f_threads -lfftw3f"
    if test "$have_fftw3d" = "yes"; then
      fftwcflags="$fftwcflags -DFFT_DOUBLE"
      fftwlibs="$fftwlibs -lfftw3_threads -lfftw3"
    fi
  else
    AC_MSG_ERROR([cannot find installed fftw3])
  fi
fi
AM_CONDITIONAL([require_fftw3], [test "$ext_fftw" = "yes" ])
AC_SUBST(fftwcflags)
AC_SUBST(fftwlibs)
])
